/* -*- c++ -*- */
#include <winsock2.h>
#include <winbase.h>
#include <winuser.h>
#include <stdio.h>

#include "socket.h"
#include "escape.h"
#include "charcode.h"
#include "code.h"

#define TNT_VERSION "tnt version 1.07"
#define COPY_LEFT "programed by Applause"
#define BUILD_DATE __DATE__

INPUT_RECORD InputRecord;

void initialize(void){
    optionNAWS=FALSE;
}

DWORD WINAPI CtoS_thread(void *param){
    int i,err,flag_ip_name;
    int numbytes,numread,numwritten;
    unsigned char charcode,keycode;
    DWORD controlkeystate;
    
    DWORD res;
    unsigned char c;

    while(1){
	if(GetFileType(hstdin)==FILE_TYPE_PIPE){
	    ReadFile(hstdin,&c,1,&numread,NULL);
	    convertandsendkey(c,0,0);
#if DEBUG
	    WriteFile(hstdout,&c,1,&numwritten,NULL);
	    send(debugsocket,&c,1,0);
#endif
	    sendflush();
	    continue;
	}else{
//	    PeekConsoleInput(hstdin,&InputRecord,1,&numread);
//	    GetNumberOfConsoleInputEvents(hstdin,&numread);
//	    if(numread!=0){
	    if(1){
		ReadConsoleInput(hstdin,&InputRecord,1,&numread);
		switch(InputRecord.EventType){
		case KEY_EVENT:
		    if(InputRecord.Event.KeyEvent.bKeyDown){
			charcode=(unsigned char)InputRecord.Event.KeyEvent.uChar.AsciiChar;
			keycode=InputRecord.Event.KeyEvent.wVirtualKeyCode;
			controlkeystate=InputRecord.Event.KeyEvent.dwControlKeyState;
			convertandsendkey(charcode,keycode,controlkeystate);

		    }else if(InputRecord.Event.KeyEvent.wVirtualKeyCode==VK_MENU){
			charcode=(unsigned char)InputRecord.Event.KeyEvent.uChar.AsciiChar;
			keycode=InputRecord.Event.KeyEvent.wVirtualKeyCode;
			controlkeystate=InputRecord.Event.KeyEvent.dwControlKeyState;
			convertandsendkey(charcode,keycode,controlkeystate);
			
		    }
		    break;
		case WINDOW_BUFFER_SIZE_EVENT:
		    checkWindowSize();
		    break;
		}
		sendflush();
		continue;
	    }
	}
    }
}

void create_CtoS_thread(void){
    DWORD dwThreadId, dwThrdParam = 1; 
    HANDLE hThread; 

    hThread = CreateThread( 
	NULL,                        // no security attributes 
        0,                           // use default stack size  
        CtoS_thread,                  // thread function 
        &dwThrdParam,                // argument to thread function 
        0,                           // use default creation flags 
	&dwThreadId
    );                // returns the thread identifier 
 
    // Check the return value for success. 
 
    if (hThread == NULL) {
	printf( "CreateThread failed." ); 
	ExitProcess(-1);
    }
}

void main(int argc,char *argv[]){
    WSADATA wsadata;
    HOSTENT FAR * lphost_entry;
    SERVENT FAR * lpserv_entry;
    SOCKADDR_IN inet_addr;
    IN_ADDR in_addr;
    fd_set fdsetread,fdsetwrite,fdseterror;
    TIMEVAL TimeVal={0,10000};
    char hostname[256];
    u_short portnumber;
    unsigned char buf[256];
    int i,err,flag_ip_name;
    int numbytes,numread,numwritten;
    unsigned char charcode,keycode;
    DWORD controlkeystate;

    
    enable_ntlm_authentication=0;

    hstdout=GetStdHandle(STD_OUTPUT_HANDLE);
    hstdin=GetStdHandle(STD_INPUT_HANDLE);
    hscreen=hstdout;

    if(GetFileType(hstdout)!=FILE_TYPE_PIPE){
	GetConsoleScreenBufferInfo(hstdout,&buffer_info);
	haltscreen=CreateConsoleScreenBuffer(
	                                 GENERIC_READ|GENERIC_WRITE,
					 0,
					 NULL,
					 CONSOLE_TEXTMODE_BUFFER,
					 NULL);
	if(haltscreen==INVALID_HANDLE_VALUE){
	    printerror("CreateConsoleScreenBuffer",GetLastError());
	}
    }

    if(GetFileType(hstdin)!=FILE_TYPE_PIPE){
	SetConsoleMode(hstdin,ENABLE_WINDOW_INPUT);
    }

    if(argc>=2){
	strcpy(hostname,argv[1]);
    }else{
	restoreConsoleSetting();
	printf(TNT_VERSION "  " COPY_LEFT "  %s %s\n\n",Build_Date,Build_Time);
	printf("%s hostname port\n",argv[0]);
	exit(1);
/*
	printf("telnet>");
	strcpy(hostname,"eriko");
*/
    }

    escinit();

    WSAStartup(0x101,&wsadata);

    if(argc>=3){
	portnumber=atoi(argv[2]);
	if(portnumber==0){
	    lpserv_entry=getservbyname(argv[2],NULL);
	    if(lpserv_entry==NULL){
		restoreConsoleSetting();
		printf("Wrong PortName : %s.\n",argv[2]);
		printerror("Error0",WSAGetLastError());
		exit(2);
	    }
	    portnumber=ntohs(lpserv_entry->s_port);
	}
    }else{
	portnumber=23;
    }
    telnetsocket=socket(AF_INET,SOCK_STREAM,PF_UNSPEC);
    if(telnetsocket==INVALID_SOCKET){
	restoreConsoleSetting();
	printerror("Error1",WSAGetLastError());
	exit(3);
    }
    err=sscanf(hostname,"%d.%d.%d.%d",
	       &in_addr.s_net,
	       &in_addr.s_host,
	       &in_addr.s_lh,
	       &in_addr.s_impno);
    if(err==4){
	flag_ip_name=1;
	lphost_entry=gethostbyaddr((char *)&in_addr,sizeof(in_addr),AF_INET);
    }else{
	flag_ip_name=0;
	lphost_entry=gethostbyname(hostname);
    }
    if(lphost_entry==NULL && !flag_ip_name){
	restoreConsoleSetting();
	err=WSAGetLastError();
	printerror("Error2",err);
	exit(4);
    }

    if(lphost_entry!=NULL){
	flag_ip_name=0;
    }
//    printf("CNAME=%s\n",lphost_entry->h_name);

    if(!flag_ip_name){
	inet_addr.sin_family=AF_INET;
	inet_addr.sin_port=htons(portnumber);
	inet_addr.sin_addr.S_un.S_addr=*(u_long *)*lphost_entry->h_addr_list;
    }else{
	inet_addr.sin_family=AF_INET;
	inet_addr.sin_port=htons(portnumber);
	inet_addr.sin_addr.S_un.S_addr=*(u_long *)&in_addr;
    }

    printf("Trying %d.%d.%d.%d...\n",
	   inet_addr.sin_addr.S_un.S_un_b.s_b1,
	   inet_addr.sin_addr.S_un.S_un_b.s_b2,
	   inet_addr.sin_addr.S_un.S_un_b.s_b3,
	   inet_addr.sin_addr.S_un.S_un_b.s_b4);

    err=connect(telnetsocket,(SOCKADDR FAR *)&inet_addr,sizeof(inet_addr));
    if(err==SOCKET_ERROR){
	restoreConsoleSetting();
	printerror("Error3",WSAGetLastError());
	exit(5);
    }else{
	if(!flag_ip_name){
	    printf("Connected to %s.\n\n",lphost_entry->h_name);
	}else{
	    printf("Connected\n\n");
	}
	fflush(stdout);
    }


#if DEBUG
    if(open_debug_socket()!=0){
	printf("Error in open_debug_socket()!\n");
    }
#endif

    /*TimeVal.tv_sec=1;
      TimeVal.tv_usec=50000;
      printf("TimeVal.tv_sec=%ld\n",TimeVal.tv_sec);
      printf("TimeVal.tv_usec=%ld\n",TimeVal.tv_usec);
      */
    FD_ZERO(&fdsetwrite);
    FD_ZERO(&fdseterror);
    
    if(portnumber==23){
	buf[0]=0xff;        //IAC
	buf[1]=0xfb;        //WILL
	buf[2]=31;          //NAWS (Window Size)
	send(telnetsocket,buf,3,0);
    }

    create_CtoS_thread();

    while(1){
	DWORD res;
	unsigned char c;
	FD_ZERO(&fdsetread);
	FD_SET(telnetsocket,&fdsetread);

	if(recvbytes==0){
	    if((err=select(0,&fdsetread,&fdsetwrite,&fdseterror,&TimeVal))==0){
		escOutputFlush();
		checkWindowSize();
		continue;
	    }
	    if(err==SOCKET_ERROR){
		restoreConsoleSetting();
		printerror("Error4",WSAGetLastError());
		exit(6);
	    }
	}
	c=recvchar(telnetsocket);
	if(c==0xff){
	    PRINTF("FF,"); //IAC
	    c=recvchar(telnetsocket);
	    PRINTF("%02X,",c);
	    if(c==0xfe){         //DON'T
		c=recvchar(telnetsocket);
		PRINTF("%02X\n",c);
	    }else if(c==0xfd){   //DO
		c=recvchar(telnetsocket);
		PRINTF("%02X\n",c);
		switch(c){
		case 24:                //TERMINAL-TYPE
		    buf[0]=0xff;	//IAC
		    buf[1]=0xfb;	//WILL
		    buf[2]=24;		//TERMINAL-TYPE
		    send(telnetsocket,buf,3,0);
		    buf[0]=0xff;	//IAC
		    buf[1]=0xfa;	//SB
		    buf[2]=24;		//TERMINAL-TYPE
		    buf[3]=0;		//IS
#if 0
		    buf[4]='v';
		    buf[5]='t';
		    buf[6]='1';
		    buf[7]='0';
		    buf[8]='0';
#else
		    buf[4]='k';
		    buf[5]='t';
		    buf[6]='e';
		    buf[7]='r';
		    buf[8]='m';
#endif
		    buf[9]=0xff;	//IAC
		    buf[10]=0xf0;	//SE
		    send(telnetsocket,buf,11,0);
		    break;
		case 31:                //NAWS (Window Size)
		    optionNAWS=TRUE;
		    //		    sendWill(c);
		    checkWindowSize();
		    break;
		case 37:
		    buf[0]=0xff;	//IAC
		    buf[1]=0xfb;	//WILL
		    buf[2]=37;		//AUTHENTICATION
		    send(telnetsocket,buf,3,0);
		    // send(telnetsocket,authdata1,sizeof(authdata1),0);
		    break;
		default:
		    sendWont(c);
		    //		    sendWill(c);
		    break;
		}
	    }else if(c==0xfa){ //SB
		i=0;
		c=recvchar(telnetsocket);
		switch(c){
		case 37:
		  PRINTF("%02X -- authentication\n",c);
		  authentication(telnetsocket);
		  break;
		default:
		  PRINTF("%02X,",c);
		  do{
		    c=recvchar(telnetsocket);
		    PRINTF("%02X,",c);
		    if(c==0xff && i==0)i=1;
		    else if(c==0xf0 && i==1)i=2;
		    else i=0;
		  }while(i!=2);
		  PRINTF("\n");
		}
	    }else if(c==0xfb){	//WILL	
		c=recvchar(telnetsocket);
		PRINTF("%02X\n",c);
		switch(c){
		default:
		    sendDo(c);
		}
	    }
	}else{
	    if(GetFileType(hstdout)==FILE_TYPE_PIPE){
		WriteFile(hstdout,&c,1,&numwritten,NULL);
	    }else{
		escout(c);
	    }
	}
    }
}
